diff --git a/drivers/video/sunxi/lcd_fb/disp_lcd.c b/drivers/video/sunxi/lcd_fb/disp_lcd.c
index 9cf693c1d..edf50646a 100644
--- a/drivers/video/sunxi/lcd_fb/disp_lcd.c
+++ b/drivers/video/sunxi/lcd_fb/disp_lcd.c
@@ -1,4 +1,4 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
+// SPDX-License-Identifier: GPL-2.0-or-later
 /* Copyright(c) 2020 - 2023 Allwinner Technology Co.,Ltd. All rights reserved. */
 /*
  * Allwinner SoCs display driver.
@@ -15,17 +15,17 @@
 #include <linux/backlight.h>
 #include <linux/hrtimer.h>
 
-#define LCD_SPI_MAX_TRANSFER_BYTE (100*PAGE_SIZE)
+#define LCD_SPI_MAX_TRANSFER_BYTE (100 * PAGE_SIZE)
 
 struct disp_lcd_private_data {
-	struct disp_lcd_flow open_flow;
-	struct disp_lcd_flow close_flow;
-	struct disp_panel_para panel_info;
-	struct panel_extend_para panel_extend_info;
-	struct panel_extend_para panel_extend_info_set;
-	u32    panel_extend_dirty;
-	struct disp_lcd_cfg lcd_cfg;
-	struct disp_lcd_panel_fun lcd_panel_fun;
+	struct sunxi_lcd_fb_disp_lcd_flow open_flow;
+	struct sunxi_lcd_fb_disp_lcd_flow close_flow;
+	struct sunxi_lcd_fb_disp_panel_para panel_info;
+	struct sunxi_lcd_fb_panel_extend_para panel_extend_info;
+	struct sunxi_lcd_fb_panel_extend_para panel_extend_info_set;
+	u32 panel_extend_dirty;
+	struct sunxi_lcd_fb_disp_lcd_cfg lcd_cfg;
+	struct sunxi_lcd_fb_disp_lcd_panel_fun lcd_panel_fun;
 	bool enabling;
 	bool disabling;
 	bool bl_enabled;
@@ -52,28 +52,31 @@ struct disp_lcd_private_data {
 };
 static spinlock_t lcd_data_lock;
 
-static struct lcd_fb_device *lcds;
+static struct sunxi_lcd_fb_device *lcds;
 static struct disp_lcd_private_data *lcd_private;
 
-struct lcd_fb_device *disp_get_lcd(u32 disp)
+struct sunxi_lcd_fb_device *sunxi_lcd_fb_disp_get_lcd(u32 disp)
 {
-	if (disp > SUPPORT_MAX_LCD - 1)
+	if (disp > g_drv_info.lcd_panel_count - 1)
 		return NULL;
 	return &lcds[disp];
 }
-static struct disp_lcd_private_data *disp_lcd_get_priv(struct lcd_fb_device *lcd)
+
+static struct disp_lcd_private_data *
+sunxi_lcd_fb_disp_lcd_get_priv(struct sunxi_lcd_fb_device *lcd)
 {
 	if (lcd == NULL) {
-		lcd_fb_wrn("param is NULL!\n");
+		LCDFB_WRN("param is NULL!\n");
 		return NULL;
 	}
 
 	return (struct disp_lcd_private_data *)lcd->priv_data;
 }
 
-static s32 disp_lcd_is_used(struct lcd_fb_device *lcd)
+static s32 sunxi_lcd_fb_disp_lcd_is_used(struct sunxi_lcd_fb_device *lcd)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	s32 ret = 0;
 
 	if ((lcd == NULL) || (lcdp == NULL))
@@ -84,123 +87,165 @@ static s32 disp_lcd_is_used(struct lcd_fb_device *lcd)
 	return ret;
 }
 
-static s32 lcd_parse_panel_para(u32 disp, struct disp_panel_para *info)
+static s32
+sunxi_lcd_fb_lcd_parse_panel_para(u32 disp,
+				  struct sunxi_lcd_fb_disp_panel_para *info)
 {
 	s32 ret = 0;
-	char primary_key[25];
 	s32 value = 0;
-	u32 Bpp = 0, lines = 0;
+	u32 lines = 0;
+	struct sunxi_lcd_fb_device *lcd;
+	struct device_node *panel_node;
+
+	lcd = sunxi_lcd_fb_disp_get_lcd(disp);
+	if (lcd == NULL)
+		return -1;
 
-	sprintf(primary_key, "lcd_fb%d", disp);
+	panel_node = lcd->panel_node;
 	memset(info, 0, sizeof(*info));
 
-	ret = lcd_fb_script_get_item(primary_key, "lcd_x", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_x", &value, 1);
 	if (ret == 1)
 		info->lcd_x = value;
 
-	ret = lcd_fb_script_get_item(primary_key, "lcd_y", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_y", &value, 1);
 	if (ret == 1)
 		info->lcd_y = value;
 
-	ret = lcd_fb_script_get_item(primary_key, "lcd_width", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_width", &value, 1);
 	if (ret == 1)
 		info->lcd_width = value;
 
-	ret = lcd_fb_script_get_item(primary_key, "lcd_height", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_height", &value, 1);
 	if (ret == 1)
 		info->lcd_height = value;
 
 	/* unit:Mhz, speed of rgb data transfer */
-	ret = lcd_fb_script_get_item(primary_key, "lcd_data_speed", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_data_speed", &value,
+					   1);
 	if (ret == 1)
 		info->lcd_data_speed = value;
 
-	ret = lcd_fb_script_get_item(primary_key, "lcd_pwm_used", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_pwm_used", &value,
+					   1);
 	if (ret == 1)
 		info->lcd_pwm_used = value;
 
 	if (info->lcd_pwm_used) {
-		ret = lcd_fb_script_get_item(primary_key, "lcd_pwm_ch", &value, 1);
+		ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_pwm_ch",
+						   &value, 1);
 		if (ret == 1)
 			info->lcd_pwm_ch = value;
 
-		ret = lcd_fb_script_get_item(primary_key, "lcd_pwm_freq", &value, 1);
+		ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_pwm_freq",
+						   &value, 1);
 		if (ret == 1)
 			info->lcd_pwm_freq = value;
 
-		ret = lcd_fb_script_get_item(primary_key, "lcd_pwm_pol", &value, 1);
+		ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_pwm_pol",
+						   &value, 1);
 		if (ret == 1)
 			info->lcd_pwm_pol = value;
 	}
 
-	ret = lcd_fb_script_get_item(primary_key, "lcd_if", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_if", &value, 1);
 	if (ret == 1)
 		info->lcd_if = value;
 
-	ret = lcd_fb_script_get_item(primary_key, "lcd_pixel_fmt", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_qspi_if", &value,
+					   1);
+	if (ret == 1) {
+		info->qspi_if = value;
+		LCDFB_DBG("panel is in qspi mode, qspi_if = %d\n", value);
+	}
+
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_pixel_fmt", &value,
+					   1);
 	if (ret == 1)
 		info->lcd_pixel_fmt = value;
 
-	ret = lcd_fb_script_get_item(primary_key, "lcd_dbi_fmt", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_dbi_fmt", &value,
+					   1);
 	if (ret == 1)
 		info->lcd_dbi_fmt = value;
 
-	ret = lcd_fb_script_get_item(primary_key, "lcd_dbi_clk_mode", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_dbi_clk_mode",
+					   &value, 1);
 	if (ret == 1)
 		info->lcd_dbi_clk_mode = value;
 
-	ret = lcd_fb_script_get_item(primary_key, "lcd_dbi_te", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_dbi_te", &value, 1);
 	if (ret == 1)
 		info->lcd_dbi_te = value;
 
-	ret = lcd_fb_script_get_item(primary_key, "fb_buffer_num", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "fb_buffer_num", &value,
+					   1);
 	if (ret == 1)
 		info->fb_buffer_num = value;
 	else
 		info->fb_buffer_num = 2;
 
-	ret = lcd_fb_script_get_item(primary_key, "lcd_dbi_if", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_dbi_if", &value, 1);
 	if (ret == 1)
 		info->dbi_if = value;
 
-
-	ret = lcd_fb_script_get_item(primary_key, "lcd_rgb_order", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_rgb_order", &value,
+					   1);
 	if (ret == 1)
 		info->lcd_rgb_order = value;
 
-	ret = lcd_fb_script_get_item(primary_key, "lcd_fps", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_fps", &value, 1);
 	if (ret == 1)
 		info->lcd_fps = value;
 	else
 		info->lcd_fps = 25;
 
-	ret = lcd_fb_script_get_item(primary_key, "lcd_spi_bus_num", &value, 1);
-	if (ret == 1)
-		info->lcd_spi_bus_num = value;
-
-	ret = lcd_fb_script_get_item(primary_key, "lcd_frm", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_frm", &value, 1);
 	if (ret == 1)
 		info->lcd_frm = value;
 
-
-	ret = lcd_fb_script_get_item(primary_key, "lcd_gamma_en", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_gamma_en", &value,
+					   1);
 	if (ret == 1)
 		info->lcd_gamma_en = value;
 
-	ret =
-	    lcd_fb_script_get_item(primary_key, "lcd_model_name",
-				     (int *)info->lcd_model_name, 2);
-
-	if (info->lcd_pixel_fmt <= LCDFB_FORMAT_BGR_888) {
-		Bpp = 4;
-	} else if (info->lcd_pixel_fmt == LCDFB_FORMAT_BGR_888 ||
-		   info->lcd_pixel_fmt == LCDFB_FORMAT_RGB_888) {
-		Bpp = 3;
-	} else if (info->lcd_pixel_fmt >= LCDFB_FORMAT_RGB_565) {
-		Bpp = 2;
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_model_name",
+					   (int *)info->lcd_model_name, 2);
+
+	switch (info->lcd_pixel_fmt) {
+	case LCDFB_FORMAT_ARGB_8888:
+	case LCDFB_FORMAT_ABGR_8888:
+	case LCDFB_FORMAT_RGBA_8888:
+	case LCDFB_FORMAT_BGRA_8888:
+	case LCDFB_FORMAT_XRGB_8888:
+	case LCDFB_FORMAT_XBGR_8888:
+	case LCDFB_FORMAT_RGBX_8888:
+	case LCDFB_FORMAT_BGRX_8888:
+		info->bpp = 4;
+		break;
+	case LCDFB_FORMAT_RGB_888:
+	case LCDFB_FORMAT_BGR_888:
+		info->bpp = 3;
+		break;
+	case LCDFB_FORMAT_RGB_565:
+	case LCDFB_FORMAT_BGR_565:
+	case LCDFB_FORMAT_ARGB_4444:
+	case LCDFB_FORMAT_ABGR_4444:
+	case LCDFB_FORMAT_RGBA_4444:
+	case LCDFB_FORMAT_BGRA_4444:
+	case LCDFB_FORMAT_ARGB_1555:
+	case LCDFB_FORMAT_ABGR_1555:
+	case LCDFB_FORMAT_RGBA_5551:
+	case LCDFB_FORMAT_BGRA_5551:
+		info->bpp = 2;
+		break;
+	default:
+		info->bpp = 4;
+		break;
 	}
+
 	info->lines_per_transfer = 1;
-	lines = LCD_SPI_MAX_TRANSFER_BYTE / (info->lcd_x * Bpp);
+	lines = LCD_SPI_MAX_TRANSFER_BYTE / (info->lcd_x * info->bpp);
 	for (; lines > 1; --lines) {
 		if (!(info->lcd_y % lines))
 			break;
@@ -212,17 +257,26 @@ static s32 lcd_parse_panel_para(u32 disp, struct disp_panel_para *info)
 	return 0;
 }
 
-static void lcd_get_sys_config(u32 disp, struct disp_lcd_cfg *lcd_cfg)
+static void
+sunxi_lcd_fb_lcd_get_sys_config(u32 disp,
+				struct sunxi_lcd_fb_disp_lcd_cfg *lcd_cfg)
 {
 	struct disp_gpio_info *gpio_info;
 	int value = 1;
-	char primary_key[20], sub_name[25];
+	char sub_name[25];
 	int i = 0;
 	int ret;
+	struct sunxi_lcd_fb_device *lcd;
+	struct device_node *panel_node;
+
+	lcd = sunxi_lcd_fb_disp_get_lcd(disp);
+	if (lcd == NULL)
+		return;
+
+	panel_node = lcd->panel_node;
 
-	sprintf(primary_key, "lcd_fb%d", disp);
 	/* lcd_used */
-	ret = lcd_fb_script_get_item(primary_key, "lcd_used", &value, 1);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_used", &value, 1);
 	if (ret == 1)
 		lcd_cfg->lcd_used = value;
 
@@ -232,16 +286,14 @@ static void lcd_get_sys_config(u32 disp, struct disp_lcd_cfg *lcd_cfg)
 	/* lcd_bl_en */
 	lcd_cfg->lcd_bl_en_used = 0;
 	gpio_info = &(lcd_cfg->lcd_bl_en);
-	ret =
-	    lcd_fb_script_get_item(primary_key, "lcd_bl_en", (int *)gpio_info,
-				     3);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, "lcd_bl_en",
+					   (int *)gpio_info, 3);
 	if (ret == 3)
 		lcd_cfg->lcd_bl_en_used = 1;
 
 	sprintf(sub_name, "lcd_bl_en_power");
-	ret =
-	    lcd_fb_script_get_item(primary_key, sub_name,
-				     (int *)lcd_cfg->lcd_bl_en_power, 2);
+	ret = sunxi_lcd_fb_script_get_item(panel_node, sub_name,
+					   (int *)lcd_cfg->lcd_bl_en_power, 2);
 
 	/* lcd fix power */
 	for (i = 0; i < LCD_POWER_NUM; i++) {
@@ -250,10 +302,9 @@ static void lcd_get_sys_config(u32 disp, struct disp_lcd_cfg *lcd_cfg)
 		else
 			sprintf(sub_name, "lcd_fix_power%d", i);
 		lcd_cfg->lcd_power_used[i] = 0;
-		ret =
-		    lcd_fb_script_get_item(primary_key, sub_name,
-					     (int *)(lcd_cfg->lcd_fix_power[i]),
-					     2);
+		ret = sunxi_lcd_fb_script_get_item(
+			panel_node, sub_name,
+			(int *)(lcd_cfg->lcd_fix_power[i]), 2);
 		if (ret == 2)
 			/* str */
 			lcd_cfg->lcd_fix_power_used[i] = 1;
@@ -266,9 +317,9 @@ static void lcd_get_sys_config(u32 disp, struct disp_lcd_cfg *lcd_cfg)
 		else
 			sprintf(sub_name, "lcd_power%d", i);
 		lcd_cfg->lcd_power_used[i] = 0;
-		ret =
-		    lcd_fb_script_get_item(primary_key, sub_name,
-					     (int *)(lcd_cfg->lcd_power[i]), 2);
+		ret = sunxi_lcd_fb_script_get_item(
+			panel_node, sub_name, (int *)(lcd_cfg->lcd_power[i]),
+			2);
 		if (ret == 2)
 			/* str */
 			lcd_cfg->lcd_power_used[i] = 1;
@@ -279,27 +330,23 @@ static void lcd_get_sys_config(u32 disp, struct disp_lcd_cfg *lcd_cfg)
 		sprintf(sub_name, "lcd_gpio_%d", i);
 
 		gpio_info = &(lcd_cfg->lcd_gpio[i]);
-		ret =
-		    lcd_fb_script_get_item(primary_key, sub_name,
-					     (int *)gpio_info, 3);
+		ret = sunxi_lcd_fb_script_get_item(panel_node, sub_name,
+						   (int *)gpio_info, 3);
 		if (!ret)
 			lcd_cfg->lcd_gpio_used[i] = 1;
 	}
 
 	sprintf(sub_name, "lcd_spi_dc_pin");
 	gpio_info = &(lcd_cfg->lcd_spi_dc_pin);
-	ret =
-		lcd_fb_script_get_item(primary_key, sub_name,
-				       (int *)gpio_info, 3);
-
+	ret = sunxi_lcd_fb_script_get_item(panel_node, sub_name,
+					   (int *)gpio_info, 3);
 
 	for (i = 0; i < LCD_GPIO_REGU_NUM; i++) {
 		sprintf(sub_name, "lcd_gpio_power%d", i);
 
-		ret =
-		    lcd_fb_script_get_item(primary_key, sub_name,
-					     (int *)lcd_cfg->lcd_gpio_power[i],
-					     2);
+		ret = sunxi_lcd_fb_script_get_item(
+			panel_node, sub_name, (int *)lcd_cfg->lcd_gpio_power[i],
+			2);
 	}
 
 	for (i = 0; i < LCD_GPIO_REGU_NUM; i++) {
@@ -307,15 +354,14 @@ static void lcd_get_sys_config(u32 disp, struct disp_lcd_cfg *lcd_cfg)
 			sprintf(sub_name, "lcd_pin_power");
 		else
 			sprintf(sub_name, "lcd_pin_power%d", i);
-		ret =
-		    lcd_fb_script_get_item(primary_key, sub_name,
-					     (int *)lcd_cfg->lcd_pin_power[i],
-					     2);
+		ret = sunxi_lcd_fb_script_get_item(
+			panel_node, sub_name, (int *)lcd_cfg->lcd_pin_power[i],
+			2);
 	}
 
 	/* backlight adjust */
 	value = 0;
-	lcd_fb_script_get_item(primary_key, "lcd_pwm_used", &value, 1);
+	sunxi_lcd_fb_script_get_item(panel_node, "lcd_pwm_used", &value, 1);
 	if (value == 1) {
 		for (i = 0; i < 101; i++) {
 			sprintf(sub_name, "lcd_bl_%d_percent", i);
@@ -324,8 +370,8 @@ static void lcd_get_sys_config(u32 disp, struct disp_lcd_cfg *lcd_cfg)
 			if (i == 100)
 				lcd_cfg->backlight_curve_adjust[i] = 255;
 
-			ret =
-				lcd_fb_script_get_item(primary_key, sub_name, &value, 1);
+			ret = sunxi_lcd_fb_script_get_item(panel_node, sub_name,
+							   &value, 1);
 			if (ret == 1) {
 				value = (value > 100) ? 100 : value;
 				value = value * 255 / 100;
@@ -333,7 +379,8 @@ static void lcd_get_sys_config(u32 disp, struct disp_lcd_cfg *lcd_cfg)
 			}
 		}
 		sprintf(sub_name, "lcd_backlight");
-		ret = lcd_fb_script_get_item(primary_key, sub_name, &value, 1);
+		ret = sunxi_lcd_fb_script_get_item(panel_node, sub_name, &value,
+						   1);
 		if (ret == 1) {
 			value = (value > 256) ? 256 : value;
 			lcd_cfg->backlight_bright = value;
@@ -341,47 +388,51 @@ static void lcd_get_sys_config(u32 disp, struct disp_lcd_cfg *lcd_cfg)
 			lcd_cfg->backlight_bright = 197;
 		}
 	}
-
-
 }
 
-static s32 disp_lcd_pin_cfg(struct lcd_fb_device *lcd, u32 bon)
+static s32 sunxi_lcd_fb_disp_lcd_pin_cfg(struct sunxi_lcd_fb_device *lcd,
+					 u32 bon)
 {
 	int i, ret;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
-	char dev_name[25];
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
-	lcd_fb_inf("lcd %d pin config, state %s, %d\n", lcd->disp,
-	       (bon) ? "on" : "off", bon);
+
+	LCDFB_INF("lcd %d pin config, state %s, %d\n", lcd->disp,
+		  (bon) ? "on" : "off", bon);
 
 	/* io-pad */
 	if (bon == 1) {
 		for (i = 0; i < LCD_GPIO_REGU_NUM; i++) {
-			if (!
-				((!strcmp(lcdp->lcd_cfg.lcd_pin_power[i], ""))
-				|| (!strcmp(lcdp->lcd_cfg.lcd_pin_power[i], "none"))))
-			ret = lcd_fb_power_enable(lcdp->lcd_cfg.lcd_pin_power[i]);
+			if (!((!strcmp(lcdp->lcd_cfg.lcd_pin_power[i], "")) ||
+			      (!strcmp(lcdp->lcd_cfg.lcd_pin_power[i], "none"))))
+				ret = sunxi_lcd_fb_power_enable(
+					lcdp->lcd_cfg.lcd_pin_power[i]);
 			if (ret)
 				return DIS_FAIL;
 		}
 	}
 
-	sprintf(dev_name, "lcd_fb%d", lcd->disp);
-	lcd_fb_pin_set_state(dev_name,
-			       (bon == 1) ?
-			       DISP_PIN_STATE_ACTIVE : DISP_PIN_STATE_SLEEP);
+	sunxi_lcd_fb_pin_set_state(lcd, (bon == 1) ? DISP_PIN_STATE_ACTIVE :
+							   DISP_PIN_STATE_SLEEP);
 
 	if (bon)
 		return DIS_SUCCESS;
 
 	for (i = LCD_GPIO_REGU_NUM - 1; i >= 0; i--) {
-		if (!((!strcmp(lcdp->lcd_cfg.lcd_pin_power[i], ""))
-			|| (!strcmp(lcdp->lcd_cfg.lcd_pin_power[i], "none"))))
-		ret = lcd_fb_power_disable(lcdp->lcd_cfg.lcd_pin_power[i]);
+		if (!((!strcmp(lcdp->lcd_cfg.lcd_pin_power[i], "")) ||
+		      (!strcmp(lcdp->lcd_cfg.lcd_pin_power[i], "none"))))
+			ret = sunxi_lcd_fb_power_disable(
+				lcdp->lcd_cfg.lcd_pin_power[i]);
 		if (ret)
 			return DIS_FAIL;
 	}
@@ -389,58 +440,78 @@ static s32 disp_lcd_pin_cfg(struct lcd_fb_device *lcd, u32 bon)
 	return DIS_SUCCESS;
 }
 
-static s32 disp_lcd_pwm_enable(struct lcd_fb_device *lcd)
+static s32 sunxi_lcd_fb_disp_lcd_pwm_enable(struct sunxi_lcd_fb_device *lcd)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
-	if (disp_lcd_is_used(lcd) && lcdp->pwm_info.dev)
-		return lcd_fb_pwm_enable(lcdp->pwm_info.dev);
-	lcd_fb_wrn("pwm device hdl is NULL\n");
+	if (sunxi_lcd_fb_disp_lcd_is_used(lcd) && lcdp->pwm_info.dev)
+		return sunxi_lcd_fb_pwm_enable(lcdp->pwm_info.dev);
+	LCDFB_WRN("pwm device hdl is NULL\n");
 
 	return -1;
 }
 
-static s32 disp_lcd_pwm_disable(struct lcd_fb_device *lcd)
+static s32 sunxi_lcd_fb_disp_lcd_pwm_disable(struct sunxi_lcd_fb_device *lcd)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	s32 ret = -1;
 	struct pwm_device *pwm_dev;
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
 		return -1;
 	}
 
-	if (disp_lcd_is_used(lcd) && lcdp->pwm_info.dev) {
-		ret = lcd_fb_pwm_disable(lcdp->pwm_info.dev);
-		pwm_dev = (struct pwm_device *)lcdp->pwm_info.dev;
-		/* following is for reset pwm state purpose */
-		lcd_fb_pwm_config(lcdp->pwm_info.dev,
-				    pwm_dev->state.duty_cycle - 1,
-				    pwm_dev->state.period);
-		lcd_fb_pwm_set_polarity(lcdp->pwm_info.dev,
-					  !lcdp->pwm_info.polarity);
-		return ret;
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
+		return -1;
 	}
-	lcd_fb_wrn("pwm device hdl is NULL\n");
 
-	return -1;
+	if (lcdp->panel_info.lcd_pwm_used) {
+		if (sunxi_lcd_fb_disp_lcd_is_used(lcd) && lcdp->pwm_info.dev) {
+			ret = sunxi_lcd_fb_pwm_disable(lcdp->pwm_info.dev);
+			pwm_dev = (struct pwm_device *)lcdp->pwm_info.dev;
+			/* following is for reset pwm state purpose */
+			sunxi_lcd_fb_pwm_config(lcdp->pwm_info.dev,
+						pwm_dev->state.duty_cycle - 1,
+						pwm_dev->state.period);
+			sunxi_lcd_fb_pwm_set_polarity(lcdp->pwm_info.dev,
+						      !lcdp->pwm_info.polarity);
+			return ret;
+		}
+	}
+
+	return 0;
 }
 
-static s32 disp_lcd_backlight_enable(struct lcd_fb_device *lcd)
+static s32
+sunxi_lcd_fb_disp_lcd_backlight_enable(struct sunxi_lcd_fb_device *lcd)
 {
 	int ret;
 	struct disp_gpio_info gpio_info;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	unsigned long flags;
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
@@ -454,35 +525,43 @@ static s32 disp_lcd_backlight_enable(struct lcd_fb_device *lcd)
 	lcdp->bl_enabled = true;
 	spin_unlock_irqrestore(&lcd_data_lock, flags);
 
-	if (disp_lcd_is_used(lcd)) {
-		unsigned int bl;
+	if (sunxi_lcd_fb_disp_lcd_is_used(lcd)) {
+		u32 bl;
 
 		if (lcdp->lcd_cfg.lcd_bl_en_used) {
 			/* io-pad */
-			ret = lcd_fb_power_enable(lcdp->lcd_cfg.lcd_bl_en_power);
+			ret = sunxi_lcd_fb_power_enable(
+				lcdp->lcd_cfg.lcd_bl_en_power);
 			if (ret)
 				return DIS_FAIL;
 
 			memcpy(&gpio_info, &(lcdp->lcd_cfg.lcd_bl_en),
 			       sizeof(gpio_info));
 
-			lcd_fb_gpio_request(&gpio_info);
+			sunxi_lcd_fb_gpio_request(&gpio_info);
 		}
-		bl = disp_lcd_get_bright(lcd);
-		disp_lcd_set_bright(lcd, bl);
+		bl = sunxi_lcd_fb_disp_lcd_get_bright(lcd);
+		sunxi_lcd_fb_disp_lcd_set_bright(lcd, bl);
 	}
 
 	return 0;
 }
 
-static s32 disp_lcd_backlight_disable(struct lcd_fb_device *lcd)
+static s32
+sunxi_lcd_fb_disp_lcd_backlight_disable(struct sunxi_lcd_fb_device *lcd)
 {
 	int ret;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	unsigned long flags;
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
@@ -495,79 +574,110 @@ static s32 disp_lcd_backlight_disable(struct lcd_fb_device *lcd)
 	lcdp->bl_enabled = false;
 	spin_unlock_irqrestore(&lcd_data_lock, flags);
 
-	if (!disp_lcd_is_used(lcd))
+	if (!sunxi_lcd_fb_disp_lcd_is_used(lcd))
 		return DIS_SUCCESS;
 
 	if (!lcdp->lcd_cfg.lcd_bl_en_used)
 		return DIS_SUCCESS;
 
-	ret = lcd_fb_power_disable(lcdp->lcd_cfg.lcd_bl_en_power);
+	ret = sunxi_lcd_fb_power_disable(lcdp->lcd_cfg.lcd_bl_en_power);
 	if (ret)
 		return DIS_FAIL;
 
 	return DIS_SUCCESS;
 }
 
-static s32 disp_lcd_power_enable(struct lcd_fb_device *lcd, u32 power_id)
+static s32 sunxi_lcd_fb_disp_lcd_power_enable(struct sunxi_lcd_fb_device *lcd,
+					      u32 power_id)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
-	if (disp_lcd_is_used(lcd)) {
+	if (sunxi_lcd_fb_disp_lcd_is_used(lcd)) {
 		if (lcdp->lcd_cfg.lcd_power_used[power_id] == 1) {
 			/* regulator type */
-			lcd_fb_power_enable(lcdp->lcd_cfg.
-			lcd_power[power_id]);
+			sunxi_lcd_fb_power_enable(
+				lcdp->lcd_cfg.lcd_power[power_id]);
+		}
 	}
-}
 
-return 0;
+	return 0;
 }
 
-static s32 disp_lcd_power_disable(struct lcd_fb_device *lcd, u32 power_id)
+static s32 sunxi_lcd_fb_disp_lcd_power_disable(struct sunxi_lcd_fb_device *lcd,
+					       u32 power_id)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
 		return -1;
 	}
 
-	if (disp_lcd_is_used(lcd)) {
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
+		return -1;
+	}
+
+	if (sunxi_lcd_fb_disp_lcd_is_used(lcd)) {
 		if (lcdp->lcd_cfg.lcd_power_used[power_id] == 1) {
 			/* regulator type */
-			lcd_fb_power_disable(lcdp->lcd_cfg.lcd_power[power_id]);
+			sunxi_lcd_fb_power_disable(
+				lcdp->lcd_cfg.lcd_power[power_id]);
 		}
 	}
 
 	return 0;
 }
 
-static s32 disp_lcd_bright_get_adjust_value(struct lcd_fb_device *lcd, u32 bright)
+static s32
+sunxi_lcd_fb_disp_lcd_bright_get_adjust_value(struct sunxi_lcd_fb_device *lcd,
+					      u32 bright)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
 		return -1;
 	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
+		return -1;
+	}
+
 	bright = (bright > 255) ? 255 : bright;
 	return lcdp->panel_extend_info.lcd_bright_curve_tbl[bright];
 }
 
-static s32 disp_lcd_bright_curve_init(struct lcd_fb_device *lcd)
+static s32
+sunxi_lcd_fb_disp_lcd_bright_curve_init(struct sunxi_lcd_fb_device *lcd)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	u32 i = 0, j = 0;
 	u32 items = 0;
 	u32 lcd_bright_curve_tbl[101][2];
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
@@ -581,44 +691,51 @@ static s32 disp_lcd_bright_curve_init(struct lcd_fb_device *lcd)
 		} else {
 			lcd_bright_curve_tbl[items][0] = 255 * i / 100;
 			lcd_bright_curve_tbl[items][1] =
-			    lcdp->lcd_cfg.backlight_curve_adjust[i];
+				lcdp->lcd_cfg.backlight_curve_adjust[i];
 			items++;
 		}
 	}
 
 	for (i = 0; i < items - 1; i++) {
-		u32 num =
-		    lcd_bright_curve_tbl[i + 1][0] - lcd_bright_curve_tbl[i][0];
+		u32 num = lcd_bright_curve_tbl[i + 1][0] -
+			  lcd_bright_curve_tbl[i][0];
 
 		for (j = 0; j < num; j++) {
 			u32 value = 0;
 
-			value =
-			    lcd_bright_curve_tbl[i][1] +
-			    ((lcd_bright_curve_tbl[i + 1][1] -
-			      lcd_bright_curve_tbl[i][1]) * j) / num;
-			lcdp->panel_extend_info.lcd_bright_curve_tbl[lcd_bright_curve_tbl[i][0] + j]
-				= value;
+			value = lcd_bright_curve_tbl[i][1] +
+				((lcd_bright_curve_tbl[i + 1][1] -
+				  lcd_bright_curve_tbl[i][1]) *
+				 j) / num;
+			lcdp->panel_extend_info.lcd_bright_curve_tbl
+				[lcd_bright_curve_tbl[i][0] + j] = value;
 		}
 	}
 	lcdp->panel_extend_info.lcd_bright_curve_tbl[255] =
-	    lcd_bright_curve_tbl[items - 1][1];
+		lcd_bright_curve_tbl[items - 1][1];
 
 	return 0;
 }
 
-s32 disp_lcd_set_bright(struct lcd_fb_device *lcd, u32 bright)
+s32 sunxi_lcd_fb_disp_lcd_set_bright(struct sunxi_lcd_fb_device *lcd,
+				     u32 bright)
 {
 	u32 duty_ns;
 	__u64 backlight_bright = bright;
 	__u64 backlight_dimming;
 	__u64 period_ns;
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	unsigned long flags;
 	bool bright_update = false;
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
@@ -634,117 +751,139 @@ s32 disp_lcd_set_bright(struct lcd_fb_device *lcd, u32 bright)
 		if (backlight_bright != 0)
 			backlight_bright += 1;
 		backlight_bright =
-		    disp_lcd_bright_get_adjust_value(lcd, backlight_bright);
+			sunxi_lcd_fb_disp_lcd_bright_get_adjust_value(
+				lcd, backlight_bright);
 
 		lcdp->lcd_cfg.backlight_dimming =
-		    (lcdp->lcd_cfg.backlight_dimming ==
-		     0) ? 256 : lcdp->lcd_cfg.backlight_dimming;
+			(lcdp->lcd_cfg.backlight_dimming == 0) ?
+				      256 :
+				      lcdp->lcd_cfg.backlight_dimming;
 		backlight_dimming = lcdp->lcd_cfg.backlight_dimming;
 		period_ns = lcdp->pwm_info.period_ns;
-		duty_ns =
-		    (backlight_bright * backlight_dimming * period_ns / 256 +
-		     128) / 256;
+		duty_ns = (backlight_bright * backlight_dimming * period_ns /
+				   256 +
+			   128) /
+			  256;
 		lcdp->pwm_info.duty_ns = duty_ns;
-		lcd_fb_pwm_config(lcdp->pwm_info.dev, duty_ns, period_ns);
+		sunxi_lcd_fb_pwm_config(lcdp->pwm_info.dev, duty_ns, period_ns);
 	}
 
 	if (lcdp->lcd_panel_fun.set_bright && lcdp->enabled) {
-		lcdp->lcd_panel_fun.set_bright(lcd->disp,
-					       disp_lcd_bright_get_adjust_value
-					       (lcd, bright));
+		lcdp->lcd_panel_fun.set_bright(
+			lcd->disp,
+			sunxi_lcd_fb_disp_lcd_bright_get_adjust_value(lcd,
+								      bright));
 	}
 
 	return 0;
 }
 
-s32 disp_lcd_get_bright(struct lcd_fb_device *lcd)
+s32 sunxi_lcd_fb_disp_lcd_get_bright(struct sunxi_lcd_fb_device *lcd)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
 	return lcdp->lcd_cfg.backlight_bright;
 }
 
-static s32 disp_lcd_set_bright_dimming(struct lcd_fb_device *lcd, u32 dimming)
+static s32
+sunxi_lcd_fb_disp_lcd_set_bright_dimming(struct sunxi_lcd_fb_device *lcd,
+					 u32 dimming)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 	u32 bl = 0;
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
 	dimming = dimming > 256 ? 256 : dimming;
 	lcdp->lcd_cfg.backlight_dimming = dimming;
-	bl = disp_lcd_get_bright(lcd);
-	disp_lcd_set_bright(lcd, bl);
+	bl = sunxi_lcd_fb_disp_lcd_get_bright(lcd);
+	sunxi_lcd_fb_disp_lcd_set_bright(lcd, bl);
 
 	return 0;
 }
 
-static s32 disp_lcd_get_panel_info(struct lcd_fb_device *lcd,
-				   struct disp_panel_para *info)
+static s32
+sunxi_lcd_fb_disp_lcd_get_panel_info(struct sunxi_lcd_fb_device *lcd,
+				     struct sunxi_lcd_fb_disp_panel_para *info)
 {
-	struct disp_lcd_private_data *lcdp = disp_lcd_get_priv(lcd);
+	struct disp_lcd_private_data *lcdp =
+		sunxi_lcd_fb_disp_lcd_get_priv(lcd);
 
-	if ((lcd == NULL) || (lcdp == NULL)) {
-		lcd_fb_wrn("NULL hdl!\n");
+	if (lcd == NULL) {
+		LCDFB_WRN("lcd handle is NULL!\n");
+		return -1;
+	}
+
+	if (lcdp == NULL) {
+		LCDFB_WRN("lcdp handle is NULL!\n");
 		return -1;
 	}
 
-	memcpy(info, (struct disp_panel_para *) (&(lcdp->panel_info)),
+	memcpy(info,
+	       (struct sunxi_lcd_fb_disp_panel_para *)(&(lcdp->panel_info)),
 	       sizeof(*info));
 	return 0;
 }
 
-
-
 /* lcd enable except for backlight */
-static s32 disp_lcd_fake_enable(struct lcd_fb_device *lcd)
+static s32 sunxi_lcd_fb_disp_lcd_fake_enable(struct sunxi_lcd_fb_device *lcd)
 {
-	lcd_fb_wrn("To be implement!\n");
+	LCDFB_WRN("To be implement!\n");
 	return 0;
 }
 
-
-
-
-void disp_lcd_vsync_handle(unsigned long data)
+void sunxi_lcd_fb_disp_lcd_vsync_handle(unsigned long data)
 {
 	struct spi_device *spi = (struct spi_device *)data;
-	struct lcd_fb_device *p_lcd = NULL;
+	struct sunxi_lcd_fb_device *p_lcd = NULL;
 	struct disp_lcd_private_data *lcdp = NULL;
 	int i;
 
-	for (i = 0; i < SUPPORT_MAX_LCD; ++i) {
-		p_lcd = disp_get_lcd(i);
+	for (i = 0; i < g_drv_info.lcd_panel_count; ++i) {
+		p_lcd = sunxi_lcd_fb_disp_get_lcd(i);
 		if (p_lcd->spi_device == spi)
 			break;
 	}
-	lcdp = disp_lcd_get_priv(p_lcd);
+	lcdp = sunxi_lcd_fb_disp_lcd_get_priv(p_lcd);
 
 	lcdp->wait_count++;
 	wake_up_interruptible(&lcdp->wait);
 }
 
-enum hrtimer_restart disp_lcd_timer_handle(struct hrtimer *timer)
+enum hrtimer_restart sunxi_lcd_fb_disp_lcd_timer_handle(struct hrtimer *timer)
 {
 	struct disp_lcd_private_data *lcdp =
-	    container_of(timer, struct disp_lcd_private_data, timer);
+		container_of(timer, struct disp_lcd_private_data, timer);
 
 	hrtimer_forward(timer, timer->base->get_time(),
 			ktime_set(0, 1000000000 / lcdp->panel_info.lcd_fps));
-	disp_lcd_vsync_handle((unsigned long)lcdp->spi_device);
+	sunxi_lcd_fb_disp_lcd_vsync_handle((unsigned long)lcdp->spi_device);
 
 	return HRTIMER_RESTART;
 }
 
-void spi_dbi_config_init(struct disp_lcd_private_data *lcdp, struct sunxi_dbi_config *dbi_config)
+void sunxi_lcd_fb_spi_dbi_config_init(struct disp_lcd_private_data *lcdp,
+				      struct sunxi_dbi_config *dbi_config)
 {
 #if defined(SUPPORT_DBI_IF)
 	if (lcdp->panel_info.lcd_if == LCD_FB_IF_DBI) {
